getAImove:
	xor a
	ld (AIjump), a
	ld (AIkick), a
	ld (AIpunch), a
	ld (keyvar), a
	ld a, (char1jump)					;jumping over character?
	or a
	jr nz, nomovexor
	ld a, (char2jump)					;walking under character?
	or a
	jr nz, nomovexor
nojchar1b:
	ld hl, char2x
	ld a, (char1x)
	ld c, a
	ld a, (hl)						;if 'xorred out' get out immediately
	sub c
	add a, 5
	cp 11
	jr nc, nomovexor
	ld b, 4
	jp moveaway
nomovexor:
	ld hl, char3x
	ld a, (char1x)
	ld c, a
	ld a, (hl)						;if 'xorred out' with other AI character, jump
	sub c
	add a, 5
	cp 11
	jr nc, nomovexor2
	ld a, %00010000
	ld (keyvar), a
nomovexor2:
	ld a, (difficulty)
	cp 3
	jp z, trainingmoving
	and %00000001
	ld b, a
	ld a, r
	and b
	jr nz, nopunchdanger
	ld a, (char2punch)				;check if punch is on
	or a
	jr nz, punchdanger
	ld a, (char2special)			;if special, move away!
	or a
	jr nz, absolutedanger
	ld a, (char2kick)				;check if kick is on (not jump kick)
	or a
	jr z, nopunchdanger
punchdanger:
	ld a, (char2x)					;check if other char is close
	ld c, a
	ld a, (char1x)
	sub c
	add a, 20
	cp 40
	jr nc, nopunchdanger
	ld a, (char1kick)
	cp 98
	jr nc, nopunchdanger		;never back out of a jump kick
absolutedanger
	ld b, 2
	jp moveaway						;else get out of the way
nopunchdanger:
	ld a, (char1punch)
	or a
	jp nz, immediateaction
	ld hl, char1x
	ld a, (AIgoal)
	cp (hl)
	jp nz, nodoattack
	ld hl, AIattack
	ld a, (hl)
	or a
	jr nz, nostartattack
	xor a
	ld (AIsteps), a
	ld a, r
	and %00000111
	inc a
	ld (hl), a
	ld a, (char1sphealth)
	cp 20
	jr c, nostartattack
	ld a, (difficulty)
	inc (hl)					;more inc's = more special moves.
	inc (hl)
	cp 1						;Easy Mode
	jr z, nostartattack
	inc (hl)
	inc (hl)					;Normal Mode/training/other weird diffiulties
	cp 4
	jr nz, nostartattack
	inc (hl)					;Hard Mode
	inc (hl)
nostartattack:
	ld a, (hl)
	cp 1
	jp z, attackseq1
	cp 2
	jp z, attackseq1
	cp 3
	jp z, attackseq3
	cp 4
	jp z, attackseq2
	cp 5
	jp z, attackseq2
	cp 6
	jp z, attackseq1
	cp 7
	jp z, attackseq3
	cp 8
	jp z, attackseq3						;rest twice as much as everything
	cp 9
	jp nc, attackseq4
nodoattack:
	ld a, r
	and %00011111
	cp 13
	jr nz, immediateaction
	xor a
	ld (AIattack), a
	ld (AIkick), a
	ld (AIpunch), a
immediateaction:
	call checkgoal
	call moveit
	ret

moveaway:
	ld a, (char1x)
	ld c, a
	ld a, (char2x)						;else we set the moving goal farther away, result:....
	cp c							;no collision
	jr c, backwardset
	ld a, c
	sub b
	ld (AIgoal), a
	jp immediateaction				;skip the formalities
backwardset:
	ld a, c
	add a, b
	ld (AIgoal), a
	jp immediateaction

checkgoal:
	ld a, (AIgoal)					;if AI trys to escape past edges of screen, jump to middle
	cp 19
	jr c, setjumpthing
	cp 95
	ret c
setjumpthing
	ld a, 63				;char2 is on odd numbers
	ld (AIgoal), a
	ld a, 1
	ld (AIjump), a
	ret

attackseq1:
	ld hl, AIsteps
	ld a, (hl)
	inc (hl)
	or a
	jr z, addhitgoal
	ld (AIkick), a
	xor a
	ld (AIattack), a
	jp immediateaction

attackseq2:
	ld a, (char1x)
	ld b, a
	ld hl, AIsteps
	ld a, (hl)
	or a
	jr z, goto36beforechar
	cp 1
	jr z, startjandgoto18
	cp 2
	jr z, startjkickandfinish
	cp 10
	jr c, waitabit
	xor a
	ld (AIattack), a
bfss2:
	inc (hl)
	jp immediateaction
goto36beforechar:
	ld a, (char2x)
	sub 37
	call c, add72
	ld (AIgoal), a
	jr bfss2
add72:
	add a, 72
	ret
startjandgoto18
	ld a, (char2x)
	cp b
	call nc, sub34
	add a, 21
	ld (AIgoal), a
	ld a, 1
	ld (AIjump), a
	jr bfss2
sub34
	sub 42
	ret
startjkickandfinish:
	ld a, 1
	ld (AIkick), a
addhitgoal:
	ld a, (char2x)
	cp b
	call nc, sub14
	add a, 7
	ld (AIgoal), a
	jr bfss2
sub14:
	sub 14
	ret
waitabit:
	jr bfss2

attackseq3:
	ld hl, AIsteps
	ld a, (hl)
	cp 0
	jr z, gotopunch
	cp 1
	jr z, waittilljp0
	cp 2
	jr z, punchit
	cp 3
	jr z, waittillpnch0
	xor a
	ld (AIattack), a
	jp immediateaction
gotopunch:
	ld a, (char1x)
	ld b, a
	jr addhitgoal
waittilljp0
	ld a, (char2jump)
	or a
	jp nz, immediateaction
	jr bfss2
punchit:
	ld a, 1
	ld (AIpunch), a
	jr bfss2
waittillpnch0:
	ld a, (char2punch)
	cp 2
	jp nc, immediateaction
	jr bfss2

attackseq4:
	ld a, (keyvar)
	or %10000100
	ld (keyvar), a
	xor a
	ld (AIattack), a
	jp immediateaction

	
moveit:
	ld a, (AIgoal)
	ld b, a
	ld a, (char1x)
	sub b
	inc a
	cp 3
	jr nc, noassignstuff
    ld a, (char1x)
	ld (AIgoal), a
noassignstuff:
	ld hl, keyvar
	ld a, (char1x)
	ld b, a
	ld a, (AIgoal)
	cp b
	jr z, gonowhere
	jr c, goleft
	ld a, %00100000
	or (hl)
	ld (hl), a
	jr checkifjump
goleft:
	ld a, %01000000
	or (hl)
	ld (hl), a
checkifjump:
	ld a, (char1jump)
	or a
	jr nz, gonowhere
	ld a, (char2jump)
	or a
	jr nz, gonowhere
	ld a, (char1x)
	ld c, a
	ld a, (char2x)
	sub c
	add a, 8
	cp 17
	jr nc, gonowhere
	ld a, 1
	ld (AIjump), a
gonowhere:
	ld a, (char2special)
	or a
	jr nz, dojumpauto
	ld a, (AIjump)
	or a
	jr z, nojumpAI
dojumpauto:
	ld a, %00010000
	or (hl)
	ld (hl), a
nojumpAI
	ld a, (AIkick)
	or a
	jr z, nokickAI
	ld a, %00000100
	or (hl)
	ld (hl), a
nokickAI
	ld a, (AIpunch)
	or a
	jr z, nopunchAI
	ld a, %00000010
	or (hl)
	ld (hl), a
nopunchAI:
	ret

trainingmoving:
	ld a, (char1x)
	ld b, a
	ld a, (AIgoal)
	cp b
	jp nz, moveit
	cp 18
	jr c, setgoalhigh
	ld a, 17
	ld (AIgoal), a
	ret
setgoalhigh:
	ld a, 95
	ld (AIgoal), a
	ret

.end
