; This source is best viewed in 1024 x 768 resolution.

; Feel free to edit this source to your whim, but please get my permission before you release
; edited source on the internet.

; I admit that this source is very spread out, but luckily for you the file names reveal what is
; in them. You can probably find where the routine that draws the special meter is under the 'special.asm'
; file for instance. Some aren't as friendly though, the instant out key instructions are in the interrupt
; routine, and that is 'greyscale.asm' Also remember that the data for the game is EVERYWHERE. I should
; have made a file called 'gamedata.asm' for this or something but I'm lazy and - oh well....
; I believe that this game is my best action game yet, and this source may be why. haha.
; Questions or Comments? EMAIL me at jedivsith@yahoo.com

#include "ti86asm.inc"

.org _asm_exec_ram
									;Your basic start. :)
	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

NUM_CHARS .equ 17					;The number of characters, change it to 3 and see what happens! (lots of things will
									;get screwed up, for one thing the title screen)
CHAR1DATA .equ $8a30				;location for the data for you (char1) (this is where I download the variable)
CHAR2DATA .equ CHAR1DATA+2048		;location for char 2 <---all of this char data is mainly the gfx and special code
GAMEDATA .equ CHAR2DATA+2048		;location for gameplay data (the chars' health, stats, location, etc.)
titlepic .equ 96*NUM_CHARS+$811e	;location of title screen in the main data variable, seen below.
									;Later the title screen is written over by the char data, but you won't see it
									;then will you?

;This has to go here because I use LITE II 86 compression.
ShellTitle:
	.db "KOTF 2 : Special NES Edition",0

ProgStart:
	ld hl, savevar-1						;load save info
	call loadstring
	ld hl, $8100							;into the actual info down there
	ld de, rounds							; just the first 30 bytes (options, released characters, and unlocked modes)
	ld bc, 30
	ldir

;ones might ask themselves, why is he assigning labels
;to addresses? what's the point? Well, it happens to be
;that the instructions for the special moves are in
;the string variables themselves, and instead of
;recompiling all 17 of the character moves with the
;new symbol table from each compile of this program,
;I decided that they can jump to the addresses shown
;below, which in turn jump to the needed subroutine.
	ld hl, puncheffect1
	ld ($80fe), hl		
	ld a, $c3
	ld ($80fd), a			;$c3 = jump command
	ld hl, drawgamespr
	ld ($80fb), hl
	ld ($80fa), a
	ld ($80f7), a

	call _runindicoff		;turn off the run indicator, which may seem pointless because I use greyscale, but this
	call clearscreen			;game does have instances where greyscale is off (the main menu for one)
	call loadgreyscale		;clear the screen and turn greyscale on
	ld hl, titlepic
	ld de, $fd00			;load dark part of title screen
	ld bc, 560
	ldir
	ld hl, titlepic+560
	ld de, $cb00			;load light part.
	ld bc, 560
	ldir
	ld hl, Authorstring
	ld de, $381b			;Load 'By:Thomas Williamson' to ($1b, $38) <--the bottom of the screen
	call drawstring
	ld hl, resetstring
	ld de, $0510			;Load 'Press ALPHA to clear' at the top
	call drawstring
	call waitkey			;wait until no keys are being pressed
pauselp:
	ld b, 1					;get the keys that are being pressed
	call keyloop
	push af
	and %00000010			;if alpha is on, reset all the data
	call nz, resetstuff
	pop af
	and %00000100			;if 2nd is not on, then go to the pauselp to wait till it is.
	jr z, pauselp
	ld b, 60				;scroll up 60 lines (more than enough)
mvtitlelp:
	push bc					;push bc because we don't want to edit it :)
	ld b, 20				;this is just a null loop to keep the scrolling a little slower, note that it is a lot
	call keyloop			;faster then the last one :)
	ld hl, $ca10			;hl =second line of the light screen ($ca10)
	ld d, h					; d = $ca, and e=00 (b equals that because it was djnzed in the keyloop) so
	ld e, b					;de =first line of light screen ($ca00)
	ld bc, 816				;copy 51 lines of the screen up
	push bc					;push 816 so we can use the same number later
	ldir					;do the copy
	ld hl, $fc10			;hl=second line of the dark screen
	ld d, h
	ld e, b					;de=first line of the dark screen
	pop bc					;pop 816 back into bc
	ldir					;do the copy
	pop bc					;pop the bc for the loop
	djnz mvtitlelp			;do this 60 times.
backmenu:
	ld a, 1
	ld (selector), a		;we start on the first selection on the menu
	ld (match), a			;whatever mode we choose, we start on match 1
	call clearscreen		;clear the screen (for many reasons)
	ld hl, Authorstring
	ld de, $381b
	call drawstring			;display the author on the bottom and the game's name on top
	ld hl, ShellTitle
	ld de, 0
	call drawstring
	call cleargamedata		;clear the game data (it's probably dirty)
menuloop:
	call closegrey			;turn off greyscale
	ld a, 2
	ld (calcnum), a			;turn linkplay or outnumbered mode off
	ld c, 1					;we start at the first menu option
	ld hl, Option1			;start text fro menu options at Option1
	ld de, $0b20
	call drawmenuopt		;draw first menu option and invert it if selected (according to selector) and inc c
	ld de, $1220
	call drawmenuopt		;next
	ld de, $1920
	call drawmenuopt		; and so on...
	ld de, $2020
	call drawmenuopt
	ld de, $2720
	call drawmenuopt
	ld de, $2e20
	call drawmenuopt
menukey:
	ld a, 8
	call hline
	ld a, $35
	call hline				;draw those neato horizontal lines over and over agian at (0, 8) and (0, $35)
	ld b, 5
	call keyloop			;get a key with a little delay for charm
	or a
	jr z, menukey			;if no key was pressed, repeat
	push af					;else push the key var
	call waitkey			;wait until no key is pressed (so we don't overreact)
	call loadgreyscale		;load the greyscale back up
	pop af					;pop the key var and load it into b
	ld b, a
	ld hl, selector			;load hl with selector because we might edit its value in keymenuup or keymenudown
	and %10000000
	call nz, keymenudown	;if down was pressed, move the selector down
	ld a, b
	and %00010000
	call nz, keymenuup		;same with up
	ld a, b
	and %00000100
	jr z, menuloop			;we we didn't press 2nd, then we didn't select anything, so let's loop agian
	ld a, (selector)		;load a with the selector
	cp 6					;if we selected exit, then we go to the return routine
	jr z, return
	ld b, 1
	ld hl, selector			;since it wasn't exit, it may be a menu, so just in case load the selector with 1
	ld (hl), b
	cp 2					;a still equals the selection remember. If we picked the second option go to teamup mode
	call z, teamupmode			;(the outnumbered mode)
	cp 3
	call z, linkplay		;go to linkplay if we picked the third option, etc.
	cp 5
	call z, optionscreen
	cp 1
	call z, tournament
	cp 4
	call z, showhelpabout
	jp backmenu				;once these great options are over with, let's go back to the menu (As well as redraw it)
return:						;the return to system routine.
	ld hl, savevar-1						;save info back into calc
	rst 20h					;load hl into OP1
	rst 10h					;find start of data of variable name pointed to in OP1 in bde
	ld a,b					;ahl = bde
	ex de,hl
	call _ahl_plus_2_pg3					;add 2 to skip header, ahl now equals start of "kotf2d" data
	call _set_abs_dest_addr			;this is our destination for the _mm_ldir
	xor a
	ld hl, rounds
	call _set_abs_src_addr		;we start copying from rounds, the start of our 30 bytes
	ld hl, 30					;we are copying 30 bytes
	xor a
	call _set_mm_num_bytes		;set this as the number of bytes to copy for _mm_ldir
	call _mm_ldir			;do it.
	jp closegrey								;close greyscale routines!

keymenudown:
	ld a, (hl)			;if selector (at hl) equals 6, return, we can't go any farther down.
	cp 6
	ret z
	inc (hl)			;increase selector if not
	ret
keymenuup:
	ld a, (hl)
	dec a	
	or a				;if decremented, and the selector equals 0, then we are already at the top-so-return
	ret z
	ld (hl), a			;else load the decremented selector thing into the variable
	ret

;this draw a menu option, and checks selector, and if it matches with c, inverts it
drawmenuopt:
	ld a, (selector)
	cp c					;if it matches with c invert it
	jr z, thisisselection
	inc c				;increase c for next selection
	jp drawstring			;else just draw the string regular (hl is automatically advanced to the next string)
thisisselection:
	set textInverse, (iy+textflags)		;set text draw to inverse
	call drawstring
	res textInverse, (iy+textflags)		;turn inverse off
	inc c				;increase c for next selection
	ret

showhelpabout:
	call closegrey			;turn greyscale off
	call clearscreen	
	ld hl, helpstring		;start with text at help string
	ld de, $0600			;start at (0, 6)
	call drawstring			;draw each string, 6 away from each other
	ld d, 12			;we don't have to define e because it wasn't changed in drawstring and we want it to stay the same
	call drawstring
	ld d, 18
	call drawstring
	ld d, 24
	call drawstring
	ld d, 30
	call drawstring
	ld d, 36
	call drawstring
	ld d, 42
	call drawstring
	ld d, 48
	call drawstring
	jp pause		;jump to the pause routine and have it return to the menu

; other than about 5 commands in playfight.asm and the actual subroutines, this is ALL
; of the linkplay routines! It's incredibly simple since one calc acts only as a
; controller. It makes for probably the most sound link engine out there, especially
; with the instant out key (x-var), which is used in the interrupts so it practically
; guarantees no calc crashes.
linkplay:
	call characterselect			;both calcs select a character
	ld (char1num), a				;assign character number 1 (for both temporarily)
	call ReceiveByte				;check if other calc is sending its character number
	or a
	jr nz, thiscalc1				;if so, then this calc is the HOST calc
	ld a, (char1num)				;inc the number so it can't equal 0
	inc a							;if not, wait until other calc receives your character number
	call SendByte
	call clearscreen				;clear the screen
	ld hl, linkstring
	ld de, $0000					;display message saying this calc is a controller calc
	call drawstring					;and pressing exit on this one effects both calcs
	ld d, 10
	call drawstring
calc2:
	ld b, 1
	call keyloop					;read key relatively fast
	call Sendbyte					;wait until other calc receives it
	ld a, (keyvar)
	and %00001000					;if exit was sent, then leave (the other calc got the
	ret nz							;message too and has already exited.)
	jr calc2						;if not, do the whole key thing agian
thiscalc1
	dec a							;assign char 2 with the byte we just recieved
	ld (char2num), a				;we have to dec it because it was 'inc'ed earlier
	ld a, 1
	ld (calcnum), a					;this is the HOST calc in linkplay (so that playfight
	call PlayFight					;knows to get the char 2 key from the linkport)
	ld a, (keyvar)
waittillotherconfirms				;if the match was over and the other calc didn't say to exit
	and %00001000					;then wait till it does
	ret nz
	call ReceiveByte
	jr waittillotherconfirms

helpstring:
	.text "Another great game from Biobytes"
	.text "By: Thomas Williamson"
	.text "Email me at jedivsith@hotmail.com"
	.text " or jedivsith@yahoo.com"
	.text "Keys: 2nd: Attack 1   Alpha: Attack 2"
	.text "Up: Jump   Graph: Pause"
	.text "X-var: instant out or teacher key"
	.text "down+attack: special"

resetstuff:
	ld hl, resetdata			;move reset data on top of the rounds data
	ld de, rounds
	ld bc, 30
	ldir
	ld hl, resetstring2
	ld de, $0510				;change string over the title pic to say that the data was cleared
	jp drawstring
	
#include "subroutes.asm"
#include "greyscale.asm"
#include "playfight.asm"
#include "AIfight.asm"
#include "selchar.asm"
#include "optscreen.asm"
#include "tourney.asm"
#include "special.asm"

savevar:
	.db 6, "kotf2d"
keyvar:
	.db 0
Authorstring:
	.text "By: Thomas Williamson"
Option1:
	.text " Tournament Mode"
	.text " Outnumbered Mode"
	.text " 2-Player Linkplay"
	.text " Help / About"
	.text " Options"
	.text " Quit"
selector:
	.db 1

rounds:
	.db 2													;number of rounds to win option
speed:
	.db 1													;speed, 1=normal, 2=fast
difficulty:	
	.db 2													;difficulty, 2=normal, 1=easy, 3+=other ones...
damage:
	.db 0, 0												;damage. 0=low, 1=high
availablechars:
	.db 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;each 0 corresponds to an unlocked character
trainingdiff:
	.db 0													;have we unlocked the training difficulty level yet?
difficultdiff:
	.db 0													;" " hard diff. yet?
doubleaidiff:
	.db 0													;same deal
twochardiff:
	.db 0
charstatsshow:
	.db 0													;have we unlocked char stat viewing yet?
outnumbermode:
	.db 0													;what about outnumbered mode?
roundselect:
	.db 0													;what about round selection?
damageselect:
	.db 0													;what about damage selection?

calcnum:
	.db 0													;mode for game play. 1=link console/tv, 2=normal, 3=outnumbered
match:
	.db 1													;match#
resetdata:
	.db 2, 1, 2, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
resetstring:
	.text "Press ALPHA to reset save data."
resetstring2:
	.text "------ALL DATA CLEAR------"

linkstring:
	.text "This calc is in controller mode."
	.text "Press exit to quit on BOTH calcs."

modenotavailable:
	call clearscreen			;clear the screen
	ld hl, notav
	ld de, $1c10				;load string into middle of screen that says "this  mode is not yet unlocked"
	call drawstring
	ld a, 10
	call hline					;draw those neato horizontal lines at (0, 10) and (0, 53)
	ld a, 53
	call hline
	ld hl, $fc00				;since strings are drawn on the darker screen, we copy them to the lighter
	ld de, $ca00				;screen to make them black
	ld bc, 1024
	ldir
	jp pause				;pause until 2nd entered.

notav:
	.text "This mode is not yet unlocked!"









.end
