;the third character works like this: the computer always draws him and determines his AI, whenever
;you attack him, it switches the char2 and char3 data. Since char2 always dies, not char2, then it switches to
;the char3 info to char2 when he dies and then reverts to normal mode.

KICK1GFX	.equ	2
KICK2GFX	.equ	3
KICK3GFX	.equ	4
JKICKGFX	.equ	5
PUNCH2GFX	.equ	6
PUNCH1GFX	.equ	7
GOTHITGFX	.equ	8

COPYAMOUNT	.equ 31		;number of char info bytes (health, stats, etc.)

playfight:
	xor a
	ld (char1wins), a				;set the rounds won by each char to 0 and the current round to 0
	ld (char2wins), a					;(it will be increased in a sec.)
	ld (curround), a
plfightnewround:
	ld hl, curround					;inc the current round
	inc (hl)
	call clearscreen			;clear the screen
	call assigndefaults		;assign character stats and stuff
	ld hl, CHAR1DATA
	ld (char1pos), hl		;set the position of the char gfx data to their positions, necessary when calling
	ld hl, CHAR2DATA		;special moves
	ld (char2pos), hl
	ld a, (calcnum)
	cp 3					;if we are on outnumbered mode (here on out Omode) then we
	jr nz, notonOmode1		;have to set up char 3's variables
	ld hl, char2health
	ld de, char3health
	ld bc, COPYAMOUNT		;make an exact copy of char2's data and put it in char 3
	ldir
	ld a, 20
	ld (char3x), a			;char 3 is at left side of the screen
	ld a, 48
	ld (char1x), a			;you get to be in the middle!
notonOmode1:
	ld a, (difficulty)
	cp 4					;HAHAHHAAA. IF on difficult mode , then the stats are increased for the enemy
	jr nz, notondifficult		;not fair? too bad.
	ld hl, char2speed
	ld a, (hl)
	or %00101000
	ld (hl), a
	ld hl, char2punchpower
	ld a, (hl)
	add a, 5			;punches more powerful
	ld (hl), a
	inc hl
	ld a, (hl)
	add a, 5			;kicks more powerful
	ld (hl), a
	inc hl
	inc hl
	dec (hl)			;punches are faster
	dec (hl)
notondifficult
	call clearbuffer	;clear buffer (the area in mem where character's are drawn, then later copied to the
						;screen (prevents flickering among other things)
	call drawchar1		;draw each character
	call drawchar2
	call drawchar3				;if Omode is on, it draws a third character, if not the routine will return immediately
	call copyscreen		;copy buffer to the real screen (we're just announcing the round and match right now)
	ld a, (match)
	ld l, a
	ld h, 0
	ld bc, $0a17		;draw match number, which is only 1 byte,so...
	call drawnumber
	ld a, (curround)
	ld l, a
	ld h, 0				;same deal with the round number
	ld bc, $1517
	call drawnumber
	ld hl, roundstring
	ld de, $150a			;draw "ROUND" on the screen
	call drawstring
	ld hl, matchstring
	ld d, $0a				;draw "MATCH" on the screen
	call drawstring
	ld a, (char1num)
	ld de, $083a			;draw the first character's name (you) on the screen
	call drawcharname
	ld a, (char2num)
	ld de, $1840			;draw the second char's name (enemy, or controller mode linkplay person)
	call drawcharname
	ld a, 5
	call hline				;put those neato horizontal lines at (0, 5) and (0, 32)
	ld a, 32
	call hline
	ld hl, vsstring
	ld de, $103d			;draw "VS." between the two char names
	call drawstring
	ld hl, $fc50
	ld de, $ca50			;darken the first 1/2 or so of the screen
	ld bc, $01c0
	ldir
	call pause				;wait until player presses 2nd.
	call clearscreen		;clear the screen
	ld a, (char1num)
	inc a
	ld (facevar+1), a
	ld de, 0				;draw char 1's face in the upperleft corner of the screen
	call drawface
	ld a, (char2num)
	inc a
	ld (facevar+1), a		;draw char 2's face in the upperright corner of the screen
	ld de, $7000
	call drawface	
loopabrag:					;called this because this is the actual game loop I can brag about (it's kinda fast for
						;all the crap it does (clear's the buffer, draws all of the sprites on the screen (up to 6)
						;coppies the buffer, reads the keypresses of char1/2, carries out unfinished command (punch,
						;kick, special), goes through a whole AI routine, etc.)
	ld hl, mcounter			;roll the move counter (which makes some characters faster then others)
	rrc (hl)
	dec hl					;update the normal counter
	inc (hl)
	call clearbufferB	;special buffer clearing routine that only erases where it needs to.
	ld hl, drawchar1
	ld ($80f8), hl		;loads drawchar1 routine into reachable spot for special moves
	call drawchar1		;draw char 1
	call movechar1		;get char1 commands and move him (including attacks and stuff)
	ld hl, drawchar2
	ld ($80f8), hl		;loads drawchar2 into spot for special moves
	call drawchar2		;get char2 AI or link commands and move him
	call movechar2
	call drawchar3		;same deal with char 3 if applicable (drawchar3 includes movement)
	ld a, (char1health)
	cp 1				;if char1's health is at 1, then he's dead
	jr z, deadchar1
	ld a, (char2health)
	cp 1				;same deal with char 2
	jr z, deadcharAI
	call updatehealth		;update health for the characters
	call updatesphealth3	;update the special health for char 3 if applicable
	call drawsphealth	;update and draw special health for chars 1+2
	call copyscreen		;copy buffer to the screen
	ld b, 1			;set keyloop to 1 (FAST)
	ld a, (speed)
	or a				;if on fast mode, don't set b to 10 (for normal speed)
	jr z, onfastmode
	ld b, 10		;set keyloop to 10 (NORMAL)
onfastmode:
	call keyloop	;the null loop that finds the keys pressed and stores them in keyvar
	and %00001000
	jr z, loopabrag		;if exit wasn't pressed, do the loopabrag thing agian
	ld a, (calcnum)
	cp 1
	jr z, loopabrag			;if linkplay is ON for this calc (this loop won't be reached by controller calc) can't exit
	xor a
	ret
deadchar1:
	call waitkey			;wait until no key is being pressed until announcement of deadness
	ld hl, youlosestring	
	ld de, $1c38			;put "YOU LOSE" smack dab in the middle of the screen
	call drawstring
	ld b, 50				;make sure you don't press 2nd over and over and miss the announcement by waiting
	call keyloop
	call pause				;now wait until the player presses 2nd
	ld hl, char2wins
	inc (hl)				;add 1 to the number of rounds won by char 2
	ld a, (rounds)
	cp (hl)
	jp nz, plfightnewround	;if the number of rounds won is NOT the same as those needed, fight a new round
	xor a					;xor a and return (a=0 meaning you lost)
	ret
deadcharAI:
	ld hl, calcnum
	ld a, (hl)					;if on Outnumbered mode, that's just 1 that's dead
	cp 3
	jr z, makenormalmode		;revert to normal mode since there is only 1 left.
	call waitkey
	ld hl, youwinstring
	ld de, $1c36				;put "YOU WIN" smack dab in the middle of the screen
	call drawstring
	ld b, 50					;wait....
	call keyloop
	call pause					;then wait some more until the player presses 2nd
	ld hl, char1wins
	inc (hl)					;add 1 to the 1st char's stats
	ld a, (rounds)
	cp (hl)						;if the number of rounds won is NOT the same as the number needed, start a new round
	jp nz, plfightnewround
	ret							;else return (and a<>0, so the parent routine knows that you won)
makenormalmode
	ld (hl), 2				;make normalmode
	ld a, 1
	ld (speed), a			;slow game down to NORMAL...so it looks kinda like the third char
							;wasn't slowig things down ;)
	call switchstatsB		;switch char2 and char3 stats
	ld hl, char3health		;clear char 3 stats (so he won't get in the way, etc.)
	ld de, char3health+1
	ld (hl), 0
	ld bc, COPYAMOUNT-1
	ldir
	jp loopabrag 			;jump back to THE GREAT LOOP

pauseme:
	ld a, 1
	out (3), a				;turn calc off
	halt					;wait until on is pressed
	ld a, 11	
	out (3), a				;turn calc back on-straight back into the game
	xor a
	ld (keyvar), a			;if we didn't reset this, then the calc would keep looping back and turning off
movechar1:
	ld a, (difficulty)
	cp 5					;if the difficulty is set to double AI, get char 1's AI move
	call z, getAImove
	ld a, (char1hit)
	or a					;if char1 is in the middle of getting hit, turn the hit gfx on.
	call nz, char1hitgfx
	ld hl, char1freeze
	ld a, (hl)				;if char1 is frozen, keep him from moving until unfrozen
	or a
	jr z, nodecfreeze		;if not frozen, no need to dec the freeze variable
	dec (hl)				;else dec the freeze variable and return so nothing else can be done.
	ret
nodecfreeze:
	ld a, (char1jump)
	or a					;if jumping CALL jumping stuff (meaning you can do other stuff while jumping)
	call nz, dojumpstuff
	ld a, (char1punch)
	or a					;if punching JP to punching stuff, meaning you CAN't do other stuff while punching
	jp nz, dopunchstuff
	ld a, (char1kick)
	or a					;same thing with kicking
	jp nz, dokickstuff
	ld a, (char1special)
	or a					;and the same with a special move
	jp nz, dospecialstuff
	ld a, (keyvar)
	ld b, a					;if graph was presses, turn calc off for later play
	and %00000001
	jr nz, pauseme
	ld a, b
	and %00010000			;if up was pressed, let's start a jump!
	call nz, startjump
	ld a, b
	and %00000010			;if alpha was pressed, let's start a punch!
	call nz, startpunch
	ld a, b
	and %00000100			;if 2nd was pressed, let's start a kick/jumpkick/special!
	call nz, startkick
returnfromjumpkick:			;return label from jumpkick (so you can move while jumpkicking)
	ld a, (keyvar)
	ld l, 0					;if left was pressed move left 
	ld b, a
	and %01000000
	jr nz, moveleft			;since it jumps, you can't stay still by pressing left + right at the same time.
	ld a, b					;same with right
	and %00100000
	jr nz, moveright
	ret
	
moveleft:
	ld a, (char3x)
	ld d, a					;load char3's x position into d (if Omode is off, char3 will be at 0, so this won't matter)
	ld a, (char2x)
	ld b, a					;load char2's x position into b
	ld a, (char1x)
	cp 16					;if we are already at the left side of the screen, can't move left
	ret c
	cp b
	call c, dorightbig		;if char 2 is to the right of us, then inc l so we can feel safe moving left
	cp d
	call c, dorightbig		;same story with char 3
	dec a
	dec a					;move left  with a (not permanent yet)
finishmove:
	ld c, a					;put your new x coordinate in c
	ld a, (char1speed)		;put the char speed in a
	ld e, a
	ld a, (mcounter)
	and e					;and AND it with the counter, so if the result is 0 then that walking bit is turned
	ret z					;off in the speed variable, and you can't move left, because it is meant to slow you down
	ld a, l
	cp 2					;if l is 2, then you can go ahead and walk
	jr z, jumpingchar1					;if walking away from en. then he's not in the way
	ld a, (char1jump)					;jumping over character?
	cp 10
	jr c, nojchar1
	cp 29
	jr c, jumpingchar1
	ld a, (char2jump)					;walking under character?
	cp 10
	jr c, nojchar1
	cp 29
	jr c, jumpingchar1
nojchar1:
	ld a, b				;if you are not walking under or jumping over a char, then check if the char is in your
	sub c				;way on the ground
	add a, 5
	cp 11
	ret c
	ld a, d				;same story with char 3
	sub c
	add a, 5
	cp 11
	ret c
jumpingchar1:
	ld a, c				;load ye old moved coordinate into a
	ld (char1x), a		;and make it so
	ret
moveright:
	ld a, (char3x)		;see the move left comments for explanation about moveing right
	ld d, a
	ld a, (char2x)
	ld b, a
	ld a, (char1x)
	cp 97
	ret nc
	cp b
	call nc, dorightbig
	cp d
	call nc, dorightbig
	inc a
	inc a
	jr finishmove
dorightbig:
	inc l				;if this is done twice, then noone is to the left of us.
	ret

startjump:
	ld hl, char1jump
	ld a, (hl)			;if we aren't already jumping....
	or a
	ret nz
	ld a, 38			;initiate a jump (38 steps)
	ld (hl), a
	ret
dojumpstuff:
	dec a
	ld (char1jump), a	;dec jumping loop var thing (when jump is over this will have got to 0)
	ld c, a
	ld b, 0				;load loop value into bc
	ld hl, charjumparc	;add it to the jump arc table starting address
	add hl, bc
	ld a, (hl)			;and find out what we need to change for this step (up or down)
	ld b, a
	ld a, (char1y)
	sub b				;change it
	ld (char1y), a
	ret

startkick:
	ld a, (keyvar)
	and %10000000			;if down is being pressed along with kick, initiate a special
	jp nz, dospecialstuff
	ld hl, char1kick		;load hl with pointer to kick var-loop thingy
	ld a, (char1kickspeed)
	ld b, a					;ld b with kick speed (it won't change to 99 unless a jump kick is in store)
	ld a, (char1jump)		;if jump is not on then we aren't doing a jump kick
	or a
	jr z, skipassign99
	cp 29					;if the jump is almost over, we aren't doing a jump kick
	jr nc, skipassign99
	cp 10					;if the jump just started, we aren't doing a jump kick
	jr c, skipassign99
	ld b, 99
skipassign99:				;else set char1kick to 99 (means a jumpkick)
	ld (hl), b
	ret
dokickstuff:
	cp 98					;if char1kick is 98 or more, then we're in the middle of a jump kick
	jr nc, jumpkickstuff
	dec a					;else dec char1kick
	ld (char1kick), a
	push af					;push the current kick var
	ld a, (char1kickpower)	;assign the char's kick power to d
	ld d, a					
	ld a, (char1kickspeed)	;load a with the kick speed
	or a					;or a, so the carry flag isn't set
	rra						;divide the kickspeed by 2 and load b with it
	ld b, a
	ld hl, char1kspd3		;load hl with the kick speed * 2/5 (for checking for different gfx)
	pop af					;pop char1kick speed into a
	cp b					;cp it to the kick speed divided by 2
	push af
	call z, puncheffect1	;if they are the same then we are halfway through the kick, and we should check for a hit
	pop af
	ld c, (hl)				;load c and d with kick speed *2/5
	ld d, c
	ld hl, char1gfx
	cp c					;if we are in the first 2/5 of the kick go to the first and second stage gfx
	jr c, finishkickanim
	push af
	ld a, (char1kickspeed)
	sub c					;subtract the kickspeed*2/5 from the total kickspeed to get kickspeed*3/5
	ld c, a
	pop af
	cp c					;if we are in the last 2/5 of the kick, then we need to go backwards into the 1st+2nd stage
	jr nc, finishkickanim
	ld a, KICK3GFX
	ld (hl), a				;else assign the midkick gfx
	ret
finishkickanim
	ld c, d
	srl c					;load c back with the kick speed*2/5 and divide it by two so it is 1/5
	cp c
	jr c, kickstartfin		;if we are in the first 1/5, then we are in the first stage
	push af
	ld a, (char1kickspeed)
	sub c					;subtract 1/5 of kickspeed from the total to get 4/5 of the kick speed
	ld c, a
	pop af
	cp c					;if we are in the last 1/5, then we shoul revert back to the first stage
	jr nc, kickstartfin
	ld a, KICK2GFX 
	ld (hl), a				;else assign the second stage of gfx
	ret
kickstartfin:
	ld a, KICK1GFX
	ld (hl), a				;assign the first stage gfx
	ret

jumpkickstuff:
	cp 98
	jr z, nokickdo				;if char1kick = 98 then we've already inflicted damage and we are waiting to land
	ld a, (char1kickpower)
	ld d, a						;else try to inflict char1kickpower damage
	call puncheffect1
	ld a, c
	cp 255
	jr nz, nokickdo				;if no damage inflicted, then we need to keep char1kick at 99
	ld a, 98
	ld (char1kick), a			;else assign in 98
nokickdo:
	ld a, (char1jump)
	cp 4						;if we are right before landing, revert back to the original gfx to make it look like a
	jr nz, keepitup				;'landing'
	ld (char1kick), a			;else load char1kick with 4, so it displays the first stage kick graphic until we land.
keepitup:
	ld a, JKICKGFX				;now we assign the jumpkick graphic for display
	ld (char1gfx), a
	jp returnfromjumpkick

startpunch:
	ld a, (char1num)
	cp 9					;if mario, can't punch, unfair isn't it?
	ret z
	ld a, (char1punchspeed)
	ld (char1punch), a		;else load the punchspeed into the punch
	ret
dopunchstuff:
	dec a
	ld (char1punch), a
	push af
	ld a, (char1punchpower)
	ld d, a
	pop af
	or a
	jr nz, notpunchend
	call puncheffect1
	ld a, (char1num)
	cp 4					;fogger's 'transportation'
	jr nz, notpunchend
	ld a, r
	and %00111111
	add a, 32
	ld (char1x), a
notpunchend
	ld a, (char1punchspeed)
	srl	a
	srl a
	ld b, a
	ld a, (char1punch)
	cp b
	jr c, startfinpunch
	push af
	ld a, (char1punchspeed)
	sub b
	ld b, a
	pop af
	cp b
	jr nc, startfinpunch
	ld a, PUNCH2GFX
finishgfxass:
	ld (char1gfx), a
	ret
startfinpunch
	ld a, PUNCH1GFX
	jr finishgfxass
puncheffect1:
	ld a, (calcnum)
	cp 3
	jp z, onOmode2			;if on outnumbered mode, we need to check BOTH AI's
peOmode:
	ld c, 0
	ld a, (char1x)
	ld b, a
	ld a, (char2x)
	cp b
	jr c, punchbackwards
	sub 16
	cp b
	ret nc
	jr backfromxcheck
punchbackwards:
	add a, 16
	cp b
	ret c
backfromxcheck
	ld a, (char1y)
	ld b, a
	ld a, (char2y)				;close to 12 away up, 20 away down
	sub b
	add a, 12
	cp 32
	ret nc
	ld a, (char1kick)
	cp 98
	jr c, nocheckifjkckeff
	ld a, (char2kick)
	or a
	jr nz, nocheckifjkckeff						;if other player isn't attacking, then jump kick isn't effective
	ld a, (char2punch)
	or a
	ret z
nocheckifjkckeff:
	ld a, d
	
hitchar2:
	ld b, a
	ld a, (char2goal)
	sub b
	jr c, deadchar2
	jr z, deadchar2
finishdchar2:
	ld (char2goal), a
	xor a
	ld (char1kick), a
	ld (char1punch), a
	ld c, 255
	ld a, (char2jump)
	or a
	jr nz, charfallhit
	ld a, 15
	ld (char2hit), a
	ret
charfallhit:
	ld a, 25
	ld (char2hit), a
	ret
deadchar2:
	ld a, 1
	jr finishdchar2

onOmode2:
	ld a, (char1pos+1)		;if an AI enemy is attacking, it will only attack you, not both, which this one checks
	cp $8a
	jp nz, peOmode
	call peOmode			;check for hit
	ld a, c
	cp 255					;if hit happened, then return
	ret z
	push de					;d contains the amount to hit for (can't lose that!)
	call switchstatsB		;make char2=char3 and char3=char2
	pop de
	call peOmode			;check for hit
	ld a, c
	cp 255					;if so, keep char change
	ret z
	jp switchstatsB			;if not, switch it back

char1hitgfx:
	dec a
	ld (char1hit), a
	ld a, GOTHITGFX
	ld (char1gfx), a
	ret

drawchar1:
	ld a, (char1gfx)
	ld b, a
	ld de, 96
	ld hl, CHAR1DATA
	or a
	jr z, nogfxloop
dcharlp:
	add hl, de
	djnz dcharlp
nogfxloop:
	ld de, char1tempspr
	push de
	ld bc, 96
	ldir
	call checkflipleftright1
	pop hl
	ld de, (char1y)
	call drawgamespr
	ld hl, counter
	ld a, (hl)
	and %00001111
	cp 8
	jr c, noassigntop
	ld b, 1
noassigntop:
	ld a, b
	ld (char1gfx), a
	ret

movechar2:
	call switchstats					;flip-flop player stats so I can utilize the same routines
	ld a, (calcnum)
	cp 1
	jr z, getbyteofcrime
	ld a, (difficulty)
	cp 6
	jr z, skipAImove
	call getAImove
skipAImove2:
	call movechar1						;no return so I can flip 'em right back
switchstats:
	ld hl, char1health
	ld de, char2health
switchstats2:
	ld b, COPYAMOUNT
sstatslp:
	ld a, (de)
	ld c, a
	ld a, (hl)
	ld (de), a
	ld (hl), c
	inc hl
	inc de
	djnz sstatslp
	ret
skipAImove:
	ld a, (keyvar)
	and %01000000
	jr nz, activateleft
	ld a, (keyvar)
	and %00100000
	call nz, activateright
	jr skipAImove2
activateleft
	ld a, (keyvar)
	xor %01000000
	or %00100000
	ld (keyvar), a
	jr skipAImove2
activateright:
	ld a, (keyvar)
	xor %00100000
	or %01000000
	ld (keyvar), a
	ret
getbyteofcrime
	call Receivebyte
	ld (keyvar), a
	and %00001000
	jr z, skipAImove2
	pop hl
	ret
switchstatsB:
	ld hl, char2health
	ld de, char3health
	jr switchstats2

drawchar2:
	ld a, (char2gfx)
	ld b, a
	ld de, 96
	ld hl, CHAR2DATA
	or a
	jr z, nogfxloop2
dcharlp2:
	add hl, de
	djnz dcharlp2
nogfxloop2:
	ld de, char2tempspr
	push de
	ld bc, 96
	ldir
	call checkflipleftright2
	pop hl
	ld de, (char2y)
	call drawgamespr
	ld hl, counter
	ld a, (hl)
	and %00001111
	cp 8
	jr c, noassigntop2
	ld b, 1
noassigntop2:
	ld a, b
	ld (char2gfx), a
	ret

drawchar3
	ld a, (calcnum)
	cp 3
	ret nz
	call switchstatsB
	call drawchar2
	call movechar2
	jp switchstatsB

checkflipleftright1:
	ld a, (char2x)
	ld b, a
	ld a, (char1x)
	cp b
	jr nc, flipit1
	ret
flipit1:
	ld hl, char1tempspr
	jp flipsprite

checkflipleftright2:
	ld a, (char1x)
	ld b, a
	ld a, (char2x)
	cp b
	jr nc, flipit2
	ret
flipit2:
	ld hl, char2tempspr
	jp flipsprite

assigndefaults:
	xor a
	ld (gfxstacknum), a
	ld a, 20
	ld (char1x), a
	ld (mcounter), a
	ld a, 91
	ld (char2x), a
	ld (AIgoal), a
	ld de, CHAR2DATA-$8000
	ld a, (char2num)
	call getcharvar
	call assignstuff		;this is the same as....
							;	call assignstuff
							; 	call switchstats
							;	call assignstuff
							;	jp switchstats....BIG byte saver!
assignstuff:
	xor a
	ld (char1hit), a
	ld (char1gfx), a
	ld (char1jump), a
	ld (char1punch), a
	ld (char1kick), a
	ld (char1special), a
	ld a, 10
	ld (char1sphealth), a
	ld a, 40
	ld (char1y), a
	ld b, 40
	ld a, (damage)
	or a
	jr nz, damageonhigh
	ld b, 80
damageonhigh:
	ld a, b
	ld (char1health), a
	dec a
	ld (char1goal), a
	ld a, (char1num)
	ld e, a
	ld d, 0
	ld l, a
	ld h, d
	add hl, de
	add hl, de
	add hl, hl
	ld de, charstats
	add hl, de
	ld de, char1punchpower
	ld bc, 6
	ldir
	jp switchstats

updatehealth:								;updates health bar and draws it.
	ld a, (char1goal)
	ld b, a
	ld a, (char1health)
	cp b
	jr z, checkoutc2hth
	dec a
	ld (char1health), a
checkoutc2hth:
	ld a, (char2goal)
	ld b, a
	ld a, (char2health)
	cp b
	jr z, nodoch2
	dec a
	ld (char2health), a
nodoch2:
	ld ix, $0180
	ld a, (char1health)
	call drawhealth
	ld ix, $018e
	ld a, (char2health)
drawhealth:
	ld b, a
	ld a, (damage)	
	or a
	jr nz, notonhighdamage
	srl b
notonhighdamage
	ld a, b
	ld b, 40
	ld de, 0
dhealthlp:
	push af
	cp b
	jr c, drawablank
	jr nz, drawthebar
	ld d, 255
	ld e, d
	jr drawablank
drawthebar
	ld d, %00111100
	ld e, %01011010
drawablank
	push de
	ld a, d
	ld c, e
	ld de, $fc00
	call dbarh
	ld a, c
	ld d, $ca
	call dbarh
	ld de, 16
	add ix, de
	pop de
	pop af
	djnz dhealthlp
	ret
dbarh
	push ix
	add ix, de
	ld e, a
	and %00001111
	ld (ix+0), a
	ld a, e
	and %11110000
	ld (ix+1), a
	ld e, 0
	pop ix
	ret

;CHARACTER 1 STATS AND AI VARIABLES
char1health		.equ	GAMEDATA
char1y			.equ 	char1health+1
char1x			.equ 	char1y+1
char1gfx		.equ	char1x+1
char1num		.equ	char1gfx+1
char1jump		.equ	char1num+1
char1kick		.equ 	char1jump+1
char1punch		.equ	char1kick+1
char1oldxy		.equ 	char1punch+1
char1goal		.equ	char1oldxy+2
char1hit		.equ 	char1goal+1
char1punchpower	.equ	char1hit+1
char1kickpower	.equ	char1punchpower+1
char1kickspeed	.equ	char1kickpower+1
char1punchspeed	.equ	char1kickspeed+1
char1kspd3		.equ	char1punchspeed+1
char1speed		.equ	char1kspd3+1
char1freeze		.equ	char1speed+1
char1special	.equ	char1freeze+1
char1specialA	.equ	char1special+1
char1specialB	.equ	char1specialA+1
char1pos		.equ	char1specialB+1
char1sphealth	.equ	char1pos+2
AI2goal			.equ	char1sphealth+1
AI2attack		.equ	AI2goal+1
AI2jump			.equ 	AI2attack+1
AI2steps		.equ	AI2jump+1
AI2kick			.equ	AI2steps+1
AI2punch		.equ	AI2kick+1
char1tempspr	.equ	AI2punch+1

;CHARACTER 2 STATS AND AI VARIABLES
char2health		.equ	char1tempspr+96
char2y			.equ 	char2health+1
char2x			.equ 	char2y+1
char2gfx		.equ	char2x+1
char2num		.equ	char2gfx+1
char2jump		.equ	char2num+1
char2kick		.equ 	char2jump+1
char2punch		.equ	char2kick+1
char2oldxy		.equ 	char2punch+1
char2goal		.equ	char2oldxy+2
char2hit		.equ 	char2goal+1
char2punchpower	.equ	char2hit+1
char2kickpower	.equ	char2punchpower+1
char2kickspeed	.equ	char2kickpower+1
char2punchspeed	.equ	char2kickspeed+1
char2kspd3		.equ	char2punchspeed+1
char2speed		.equ	char2kspd3+1
char2freeze		.equ	char2speed+1
char2special	.equ	char2freeze+1
char2specialA	.equ	char2special+1
char2specialB	.equ	char2specialA+1
char2pos		.equ	char2specialB+1
char2sphealth	.equ	char2pos+2
AIgoal			.equ	char2sphealth+1
AIattack		.equ	AIgoal+1
AIjump			.equ 	AIattack+1
AIsteps			.equ	AIjump+1
AIkick			.equ	AIsteps+1
AIpunch			.equ	AIkick+1
char2tempspr	.equ	AIpunch+1

;CHARACTER 3 STATS AND AI VARIABLES (for Outnumbered  mode)
char3health		.equ	char2tempspr+96
char3y			.equ 	char3health+1
char3x			.equ 	char3y+1
char3gfx		.equ	char3x+1
char3num		.equ	char3gfx+1
char3jump		.equ	char3num+1
char3kick		.equ 	char3jump+1
char3punch		.equ	char3kick+1
char3oldxy		.equ 	char3punch+1
char3goal		.equ	char3oldxy+2
char3hit		.equ 	char3goal+1
char3punchpower	.equ	char3hit+1
char3kickpower	.equ	char3punchpower+1
char3kickspeed	.equ	char3kickpower+1
char3punchspeed	.equ	char3kickspeed+1
char3kspd3		.equ	char3punchspeed+1
char3speed		.equ	char3kspd3+1
char3freeze		.equ	char3speed+1
char3special	.equ	char3freeze+1
char3specialA	.equ	char3special+1
char3specialB	.equ	char3specialA+1
char3pos		.equ	char3specialB+1
char3sphealth	.equ	char3pos+2
AI3goal			.equ	char3sphealth+1
AI3attack		.equ	AI3goal+1
AI3jump			.equ 	AI3attack+1
AI3steps		.equ	AI3jump+1
AI3kick			.equ	AI3steps+1
AI3punch		.equ	AI3kick+1
char3tempspr	.equ	AI3punch+1

counter			.equ	char3tempspr+96
mcounter		.equ	counter+1

curround		.equ	mcounter+1
char1wins		.equ	curround+1
char2wins		.equ 	char1wins+1

gfxstacknum		.equ	char2wins+1
gfxstack		.equ	gfxstacknum+1

.db 0
charstats:
;punch power, kick power, k speed, p speed, kspeed*2/5, char speed
	.db 4, 	9, 	25, 6, 	10, %11111111				;Double Dragon
	.db 3, 	8, 	20, 5, 	8, 	%11111111				;Leonardo
	.db 4, 	8, 	20, 6, 	8, 	%01110111				;Contra
	.db 4, 	10,	15, 6, 	6, 	%11111111				;Yugi
	.db 0, 	7, 	20, 12,	8,	%11111111				;Fogger
	.db 14,	2, 	20,	9, 	8, 	%01110111				;Hypo-Radio Gel
	.db 5, 	8, 	20, 6, 	8,	%11111111				;Robbie
	.db 5, 	9, 	20, 6, 	8, 	%01110111				;Simon
	.db 5, 	8, 	10, 7, 	4, 	%11111111				;Ninja Gaiden
	.db 4, 	11,	25, 4, 	10,	%01110111				;Mario
	.db 3, 	7, 	15, 6, 	6, 	%01110111				;Kirby
	.db 2, 	5, 	25, 8, 	10,	%01011011				;Cecil
	.db 4, 	8, 	20, 5, 	8, 	%11111111				;Mega Man
	.db 3, 	10,	15, 7, 	6, 	%01110111				;Black Mage
	.db 4, 	8, 	15, 6, 	6, 	%11111111				;Samus
	.db 3, 	10,	15, 6, 	6, 	%11111111				;Link
	.db 8, 	12,	10, 4, 	4, 	%11111111				;Princess Toadstool

charjumparc:
	.db 252, 252, 253, 253, 253, 254, 254, 254, 254, 254, 254
	.db 255, 255, 255, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4


charnames:
	.db 0		;I mixed var. names and names!
	.db 6, "CBilly Lee", 0	
	.db 6, "CLeonardo", 0
	.db 7, "CContraman", 0
	.db 5, "CYugi", 0
	.db 7, "CFogger", 0
	.db 5, "CHypo-Radio Gel", 0
	.db 7, "CRobbie", 0
	.db 6, "CSimon Belmont", 0
	.db 4, "CRyu", 0
	.db 6, "CMario", 0
	.db 6, "CKirby", 0
	.db 6, "CCecil", 0
	.db 5, "CMega Man", 0
	.db 6, "CBlack Mage", 0
	.db 6, "CSamus", 0
	.db 5, "CLink", 0
	.db 8, "CPrincess Toadstool", 0

vsstring:
	.text "VS."
youlosestring:
	.text "You lost!"
youwinstring:
	.text "You Won!"
roundstring:
	.text "ROUND"
matchstring:
	.text "MATCH"

;Yep! this is it, the one and only backdrop!
Backdrop:
 ;Tile 0
 .db $03,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$00
 .db $00,$00,$0C,$00,$01,$00,$00,$00,$80,$00,$00,$80,$00,$30,$00,$00
 .db $00,$00,$30,$00,$02,$00,$00,$00,$80,$00,$00,$40,$00,$0C,$00,$00
 .db $00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00

.end
